<!DOCTYPE html>
<html lang="en">
{% include 'header.html' %}
<body>
<div id="segment_id">
    {% include 'menu.html' %}
    <script>
        $(function () {
            $('.message .close')
                .on('click', function () {
                    $(this)
                        .closest('.message')
                        .transition('fade')
                    ;
                });


            $('.ui.dropdown.selection').dropdown({});


            $('.menu .item').tab({
                history: true,
                historyType: 'hash'
            });

            $('.ui.dropdown.selection').dropdown({});
        });
    </script>
    <style>
        .ui.dropdown .menu {
            min-width: 100%;
        }

        .ui.dropdown.dropdown .menu > .input {
            min-width: 80%;
        }
    </style>
    <div class="ui grid">
        <div class="ui column" style="width: 75px; padding-top: 50px;">
            {% include 'project/sidebar.html' %}
        </div>

        <script>


            $(function () {
                $('#issues_list').DataTable({
                    "order": [[3, "desc"]],
                    "iDisplayLength": -1,
                    "bLengthChange": false,
                    "columnDefs": [{
                        "targets": 0,
                        "orderable": false,
                        "width": 20
                    }, {
                        "targets": 1,
                        "orderable": true
                    }, {
                        "targets": 2,
                        "orderable": true
                    }, {
                        "targets": 3,
                        "orderable": true,
                        "width": 40
                    }, {
                        "targets": 4,
                        "orderable": false,
                        "width": 50
                    }],
                    language: {
                        searchPlaceholder: "Search...",
                        search: ""
                    },
                    autoWidth: false,
                    "paging": false,
                    "bInfo": false
                });
                $('#rules_list').DataTable({
                    "order": [[2, "desc"]],
                    "iDisplayLength": -1,
                    "bLengthChange": false,
                    "columnDefs": [{
                        "targets": 0,
                        "orderable": false,
                        "width": 20
                    }, {
                        "targets": 1,
                        "orderable": true
                    }, {
                        "targets": 2,
                        "orderable": true,
                        "width": 100
                    }, {
                        "targets": 3,
                        "orderable": false,
                        "width": 100
                    }],
                    language: {
                        searchPlaceholder: "Search...",
                        search: ""
                    },
                    autoWidth: false,
                    "paging": false,
                    "bInfo": false
                });
            });

            all_issues_selected = false;

            function select_all_issues() {
                results = document.querySelectorAll("[id=issue_checkbox]");
                all_issues_selected = !all_issues_selected;
                for (let element of results) {
                    element.checked = (all_issues_selected) ? "checked" : "";
                }
            }

            all_rules_selected = false;

            function select_all_rules() {
                results = document.querySelectorAll("[id=rule_checkbox]");
                all_rules_selected = !all_rules_selected;
                for (let element of results) {
                    element.checked = (all_rules_selected) ? "checked" : "";
                }
            }

            function submit_form() {
                form_elem = $('#form_id')[0];
                issues_elem = $('#issues_ids')[0];
                rules_elem = $('#rules_ids')[0];

                // set
                results = document.querySelectorAll("[id=issue_checkbox]");
                for (let element of results) {
                    if (element.checked) {
                        issues_elem.value += ',' + element.value;
                    }
                }

                results = document.querySelectorAll("[id=rule_checkbox]");
                for (let element of results) {
                    if (element.checked) {
                        rules_elem.value += ',' + element.value;
                    }
                }

                if (issues_elem.value !== "" && rules_elem.value !== "") {
                    form_elem.submit();
                } else {
                    $('body').toast({
                        class: 'error',
                        position: 'bottom right',
                        message: 'Need to select issues and rules!'
                    });
                }

            }

        </script>

        <div class="ui column" style="width: calc(100% - 75px)">
            <h1 class="ui header">Use issue replace rules</h1>
            <form style="visibility: hidden" method="post" action="/project/{{ current_project['id'] }}/issues/rules/submit" id="form_id">
                <input name="csrf_token" value="{{ csrf_token() }}">
                <input name="issues_ids" id="issues_ids" value="">
                <input name="rules_ids" id="rules_ids" value="">
            </form>
            {% set rules_list = db.check_user_all_issue_rules(current_user['id'], current_user['email']) %}
            {% set issues_list = db.select_project_issues(current_project['id']) %}
            <div class="ui grid">
                <div class="three column row">
                    <div class="column" style="width: calc(33.33333333% - 20px) !important; padding-right: unset;">
                        <h2 class="ui header">Issues to change</h2>
                        <div style="width:100%; height: 500px; overflow: auto;">
                            <table id="issues_list" class="ui table" style="width:100%; overflow: auto;">
                                <thead>
                                <tr>
                                    <th>
                                        <div class="ui fitted big checkbox">
                                            <input type="checkbox" style="transform: scale(1.2); margin-left: 4px;" name="issue_checkbox" onchange="select_all_issues();">
                                            <label></label>
                                        </div>
                                    </th>
                                    <th>Name</th>
                                    <th>Description</th>
                                    <th>CVSS</th>
                                    <th style="width: 70px;">Action</th>
                                </tr>
                                </thead>
                                <tbody>
                                {% for current_issue in issues_list %}
                                    <tr style="background-color:{% if current_issue['cvss'] == 0 %}rgb(192, 247, 255);{% elif current_issue['cvss'] <= 3.9 %}rgb(195, 255, 205);{% elif current_issue['cvss'] <= 6.9 %}rgb(255, 253, 194);{% elif current_issue['cvss'] <= 8.9 %}rgb(243, 195, 117);{% else %}rgb(255, 178, 178);{% endif %}">
                                        <td>
                                            <div class="ui fitted big checkbox">
                                                <input type="checkbox" style="transform: scale(1.2); margin-left: 4px;" value="{{ current_issue['id'] }}" name="issue_checkbox" id="issue_checkbox" {% if current_issue['id'] in issue_ids %}checked{% endif %}>
                                                <label></label>
                                            </div>
                                        </td>
                                        <td>{{ current_issue['name'] }}</td>
                                        <td style="word-break: break-all; white-space:pre-wrap;">{{ '\n'.join(current_issue['description'].split('\n')[:5])[:30] }}...</td>
                                        <td>{{ current_issue['cvss'] }}</td>
                                        <td  style="width: 70px;">
                                            <a class="ui icon blue button" href="/project/{{ current_project['id'] }}/issue/{{ current_issue['id'] }}/" target="_blank" rel="noopener noreferrer">
                                                <i class="linkify icon"></i>
                                            </a>
                                        </td>
                                    </tr>
                                {% endfor %}
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="column" style="width: calc(33.33333333% - 20px) !important">
                        <h2 class="ui header">Rules to use</h2>
                        <div style="width:100%; height: 500px; overflow: auto;">
                            <table id="rules_list" class="ui table" style="width:100%; overflow: auto;">
                                <thead>
                                <tr>
                                    <th>
                                        <div class="ui fitted big checkbox">
                                            <input type="checkbox" style="transform: scale(1.2); margin-left: 4px;" name="rule_checkbox" onchange="select_all_rules();">
                                            <label></label>
                                        </div>
                                    </th>
                                    <th>Name</th>
                                    <th>Owner</th>
                                    <th>Action</th>
                                </tr>
                                </thead>
                                <tbody>
                                {% for current_rule in rules_list %}
                                    <tr>
                                        <td>
                                            <div class="ui fitted big checkbox">
                                                <input type="checkbox" style="transform: scale(1.2); margin-left: 4px;" name="rule_checkbox" value="{{ current_rule['id'] }}" {% if current_rule['id'] in rule_ids %}checked{% endif %} id="rule_checkbox">
                                                <label></label>
                                            </div>
                                        </td>
                                        <td>{{ current_rule['name'] }}</td>
                                        <td>{% if current_rule['user_id'] %}Personal{% else %}Team: {{ db.select_team_by_id(current_rule['team_id'])[0]['name'] }}{% endif %}</td>
                                        <td>
                                            <a class="ui icon blue button" href="/issue_rule/{{ current_rule['id'] }}/" target="_blank" rel="noopener noreferrer">
                                                <i class="linkify icon"></i>
                                            </a>
                                        </td>
                                    </tr>
                                {% endfor %}
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="column" style="width: calc(33.33333333% - 20px) !important">
                        <h2 class="ui header">Additional options</h2>
                        <button class="ui button blue" type="button" onclick="submit_form();"><i class="ui icon plus"></i>Submit</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    {% include 'footer.html' %}
</div>
</div>
</body>
</html>